//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "uPlotForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "GLRender"
#pragma link "GLRenderLib"
#pragma resource "*.dfm"

float GetRGB ( int Component , float Value )
{
  if ( Component == 3 ) return  exp( -20*pow(Value - 0.3  , 2 )) ;
  if ( Component == 2 ) return  exp(  -8*pow(Value - 0.48 , 2 )) ;
  if ( Component == 1 ) return  exp(  -4*pow(Value - 1    , 2 )) ;

  return 0 ;
}

//---------------------------------------------------------------------------
__fastcall TPlotForm::TPlotForm(TComponent* Owner)
        : TForm(Owner)
{
}
__fastcall TPlotForm::TPlotForm(TComponent* Owner , void* EnterData )
        : TForm(Owner)
{
  // Data copying
  Caption = ((KGP*)EnterData) -> Title   ;
  PlotData.Xdim  = ((KGP*)EnterData) -> Xdim    ;
  PlotData.Ydim  = ((KGP*)EnterData) -> Ydim    ;
  PlotData.DataPointer = new float[ PlotData.Xdim * PlotData.Ydim ] ;
  memcpy ( (void *)PlotData.DataPointer , (void *)((KGP*)EnterData) -> DataPointer , sizeof(float)*PlotData.Xdim * PlotData.Ydim )   ;
  PlotData.ParentWin = ((KGP*)EnterData) -> ParentWin ;
  PlotData.Debug = ((KGP*)EnterData) -> Debug ;

  // Normalize Z-data
  float MaxData = -9.99999999e+38 ;
  float MinData =  9.99999999e+38 ;
  for ( int Address = 0 ; Address <  PlotData.Xdim * PlotData.Ydim  ; Address ++ )
      {
        if ( MinData > *( PlotData.DataPointer + Address) ) MinData = *( PlotData.DataPointer + Address ) ;
      }

  for ( int Address = 0 ; Address <  PlotData.Xdim * PlotData.Ydim  ; Address ++ )
      {
        *( PlotData.DataPointer + Address) - MinData ;
      }

  for ( int Address = 0 ; Address <  PlotData.Xdim * PlotData.Ydim  ; Address ++ )
      {
        if ( MaxData < *( PlotData.DataPointer + Address ) ) MaxData = *( PlotData.DataPointer + Address ) ;
      }

  if ( MaxData == 0 ) MaxData = 1 ;
  for ( int Address = 0 ; Address <  PlotData.Xdim * PlotData.Ydim  ; Address ++ )
      {
       *( PlotData.DataPointer + Address ) /= MaxData  ;
      }



  DeltaY     = 0.5   ;
  DeltaX     = 0.5   ;
  DeltaAngel = 5     ;

  Mode  = 1          ;
  Alpfa = 0          ;
  Beta  = 0          ;
  Gama  = 0          ;
  Scale = 1          ;
  Xpos  = 0          ;
  Ypos  = 0          ;
  Zpos  = -30        ;
  PrevMousePosX = 0  ;
  PrevMousePosY = 0  ;

  // init BackGround color ;
  BackGroundColor = (TColor)0xb9b9b9 ;
  BackGroundAlpha = 1 ;
  // init fog
  FogMode      = GL_EXP2 ;
  Density      = 0.035   ;
  FogColor [0] = 0.5     ;
  FogColor [1] = 0.5     ;
  FogColor [2] = 0.5     ;
  FogColor [3] = 1       ;

  PlotMode = 2 ;

  // Load cursors
  Screen->Cursors[1] = LoadCursor(HInstance, "SCALE");
  Screen->Cursors[2] = LoadCursor(HInstance, "MOVE");
  Screen->Cursors[3] = LoadCursor(HInstance, "ROTATE_XY");
  Screen->Cursors[4] = LoadCursor(HInstance, "ROTATE_Z");
  Screen->Cursors[5] = LoadCursor(HInstance, "IDLE");

}
__fastcall TPlotForm::~TPlotForm()
{
   delete [] PlotData.DataPointer  ;
}
//---------------------------------------------------------------------------
void __fastcall TPlotForm::TColorToGL ( TColor Color , float& R , float& G , float& B)
{

  R = (float)( Color & 0xff ) / 255 ;
  G = (float)( (Color & 0xff00)  >> 8 ) / 255 ;
  B = (float)( (Color & 0xff0000) >> 16 ) / 255 ;
}
//---------------------------------------------------------------------------
void __fastcall TPlotForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 PostQuitMessage  (0) ;    
}
//---------------------------------------------------------------------------


void __fastcall TPlotForm::OpenGLPanel1Paint(TObject *Sender)
{
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

 glPushMatrix();

 glTranslated( Xpos , Ypos , Zpos );
 glScalef ( Scale , Scale , Scale ) ;
 glRotatef( Alpfa , 1.0, 0.0, 0.0);
 glRotatef( Beta  , 0.0, 1.0, 0.0);
 glRotatef( Gama  , 0.0, 0.0, 1.0);

 glCallList(BASIS)  ;
 glCallList ( PlotMode ) ;

 glPopMatrix();
}
//---------------------------------------------------------------------------

void __fastcall TPlotForm::OpenGLPanel1Resize(TObject *Sender)
{
 glViewport(0,0,(GLsizei)OpenGLPanel1->Width,(GLsizei)OpenGLPanel1->Height);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 if ( OpenGLPanel1->Height==0) gluPerspective(45, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
 else gluPerspective(45, (GLdouble)OpenGLPanel1->Width/(GLdouble)OpenGLPanel1->Height,1.0, 2000.0);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
}
//---------------------------------------------------------------------------

void __fastcall TPlotForm::OpenGLPanel1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   StatusBar1 -> Panels -> Items[0] -> Text = "Pos : x = " + AnsiString(X) + " y = " + AnsiString(Y);

    OpenGLPanel1 -> Cursor = (TCursor)5 ;

    if ( Shift.Contains( ssRight ))
     {
      OpenGLPanel1 -> Cursor = (TCursor)1 ;
      StatusBar1 -> Panels -> Items[0] -> Text = "Scale : ";
      if ( Y < PrevMousePosY )
         {
          Scale += Scale * 0.05 ;
         }
      else
         {
          Scale -= Scale * 0.05  ;
         }
      StatusBar1 -> Panels -> Items[0] -> Text = "Scale : " + AnsiString(Scale) ;
     }
    if ( Shift.Contains(ssShift))
     {
     OpenGLPanel1 -> Cursor = (TCursor)2 ;
     if ( Y < PrevMousePosY )
         {
          Ypos += DeltaY ;
         }
     if ( Y > PrevMousePosY )
         {
          Ypos -= DeltaY  ;
         }
      if ( X < PrevMousePosX )
         {
          Xpos -= DeltaX ;
         }
      if ( X > PrevMousePosX )
         {
          Xpos += DeltaX  ;
         }

      StatusBar1 -> Panels -> Items[0] -> Text = "Move : Xpos = " + AnsiString (Xpos) + " Ypos = " + AnsiString (Ypos);
     }

    if ( Shift.Contains(ssCtrl))
     {
      OpenGLPanel1 -> Cursor = (TCursor)4 ;
      if ( X < PrevMousePosX )
         {
          Gama -= DeltaAngel ;
         }
      if ( X > PrevMousePosX )
         {
          Gama += DeltaAngel ;
         }

      StatusBar1 -> Panels -> Items[0] -> Text = "Rotate : Gama = " + AnsiString (Gama) ;
     }

    if ( Shift.Contains(ssLeft))
     {
      OpenGLPanel1 -> Cursor = (TCursor)3 ;
      if ( Y < PrevMousePosY )
         {
          Alpfa -= DeltaAngel ;
         }
      if ( Y > PrevMousePosY )
         {
         Alpfa += DeltaAngel ;
         }
      if ( X < PrevMousePosX )
         {
          Beta -= DeltaAngel ;
         }
      if ( X > PrevMousePosX )
         {
          Beta += DeltaAngel ;
         }

      StatusBar1 -> Panels -> Items[0] -> Text = "Rotate : Alpha = " + AnsiString (Alpfa) + " Rotate : Beta = " + AnsiString (Beta);
     }

    OpenGLPanel1Paint (NULL)     ;
    OpenGLPanel1 -> Repaint ()   ;

    PrevMousePosX = X ;
    PrevMousePosY = Y ;
}
//---------------------------------------------------------------------------
void __fastcall TPlotForm::FormKeyPress(TObject *Sender, char &Key)
{
  if ( PlotMode == 2 )
       {
        PlotMode = 3 ;
       }
  else
       {
        PlotMode = 2 ;
       }
  OpenGLPanel1Paint (NULL)     ;
  OpenGLPanel1 -> Repaint ()   ;
}
//---------------------------------------------------------------------------

void __fastcall TPlotForm::OpenGLPanel1RenderInit(TObject *Sender)
{
  glViewport(0,0,(GLsizei)OpenGLPanel1->Width,(GLsizei)OpenGLPanel1->Height);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  if ( OpenGLPanel1->Height==0) gluPerspective(45, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
  else  gluPerspective(45, (GLdouble)OpenGLPanel1->Width / (GLdouble)OpenGLPanel1->Height,1.0, 2000.0);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_POLYGON_SMOOTH);
  glEnable(GL_BLEND) ;
  glEnable(GL_FOG) ;

  GLfloat r , g , b ;
  TColorToGL ( BackGroundColor , r , g , b ) ;
  glClearColor( r , g , b , BackGroundAlpha );

  glFogi  ( GL_FOG_MODE    , FogMode  ) ;
  glFogf  ( GL_FOG_DENSITY , Density  ) ;
  glFogfv ( GL_FOG_COLOR   , FogColor ) ;



  glLineWidth( BASIS );
  glNewList (1, GL_COMPILE );
     glBegin(GL_LINES);
       glColor3d(1,0,0);
       glVertex3f (1,0,0) ;
       glVertex3f (0,0,0) ;
        glColor3d(0,1,0);
       glVertex3f (0,1,0) ;
       glVertex3f (0,0,0) ;
        glColor3d(0,0,1) ;
       glVertex3f (0,0,1) ;
       glVertex3f (0,0,0) ;
     glEnd();
  glEndList() ;

  glNewList (3, GL_COMPILE );
    glBegin(GL_LINES);
    glColor3d(1,0,0);     //  
     for(int X = 1 ; X < ( ( PlotData.Xdim ) -1 ) ; X++)
        {
         float x , y ;
         for(int Y = 0 ; Y < ( ( PlotData.Ydim ) -1 ) ; Y++)
            {
             x = (X-PlotData.Xdim/2) ; y = (Y-PlotData.Ydim/2) ;

             glColor3d(*(PlotData.DataPointer + X*(PlotData.Xdim) + Y ),0,0);     //  
             glVertex3d(x,y,10**(PlotData.DataPointer + X*(PlotData.Xdim) + Y )); //  
             glVertex3d(x-1,y,10**(PlotData.DataPointer + (X - 1) * (PlotData.Xdim) + Y ));
            }
         }
     for( int X = 1 ; X < ( ( PlotData.Xdim ) -1 ) ; X ++ )
         {
           float x , y ;
           for(int Y = 1 ; Y < ( (PlotData.Ydim ) -1 ); Y ++ )
               {
                x = (X-PlotData.Xdim/2) ; y = (Y-PlotData.Ydim/2) ;
                glColor3f(*(PlotData.DataPointer + X*PlotData.Xdim + Y ),0,0);     //  
                glVertex3f(x,y,10**(PlotData.DataPointer + X*PlotData.Xdim + Y )); //  
                glVertex3f(x,y-1,10**(PlotData.DataPointer + X*PlotData.Xdim + Y - 1 ));
               }
         }
    glEnd();
  glEndList() ;

  glPolygonMode(GL_BACK , GL_FILL ) ;
  glNewList (2, GL_COMPILE );
  for(int X=1 ; X < PlotData.Xdim - 1 ; X++)
     {
      for(int Y=1 ; Y < PlotData.Ydim - 1 ; Y++)
          {
            float x , y ;
            x = (X-PlotData.Xdim/2) ; y = (Y-PlotData.Ydim/2) ;
          glBegin(GL_TRIANGLES);
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + X * PlotData.Xdim + Y)) , GetRGB(2 , *(PlotData.DataPointer + X * PlotData.Xdim + Y)) , GetRGB(3 , *(PlotData.DataPointer + X * PlotData.Xdim + Y) )) ;
             glVertex3f(x,y,10**(PlotData.DataPointer + X * PlotData.Xdim + Y));
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y)) , GetRGB(2 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y)) , GetRGB(3 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y) ) );
             glVertex3f(x+1,y,10**(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y));
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) , GetRGB(2 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) , GetRGB(3 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) ) ;
             glVertex3f(x+1,y+1,10**(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1));
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + X * PlotData.Xdim + Y)) , GetRGB(2 , *(PlotData.DataPointer + X * PlotData.Xdim + Y)) , GetRGB(3 , *(PlotData.DataPointer + X * PlotData.Xdim + Y)) ) ;
             glVertex3f(x,y,10**(PlotData.DataPointer + X * PlotData.Xdim + Y));
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + X * PlotData.Xdim + Y+1)) , GetRGB(2 , *(PlotData.DataPointer + X * PlotData.Xdim + Y+1)) , GetRGB(3 , *(PlotData.DataPointer + X * PlotData.Xdim + Y+1)) ) ;
             glVertex3f(x,y+1,10**(PlotData.DataPointer + X * PlotData.Xdim + Y+1));
            glColor3f ( GetRGB(1 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) , GetRGB(2 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) , GetRGB(3 , *(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1)) ) ;
             glVertex3f(x+1,y+1,10**(PlotData.DataPointer + (X+1) * PlotData.Xdim + Y+1));
          glEnd();
         }
      }
  glEndList() ;
}
//---------------------------------------------------------------------------

