//---------------------------------------------------------------------------

#ifndef uPlotFormH
#define uPlotFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>

#include <ExtCtrls.hpp>
#include <OpenGLPanel.h>
#include "GLRender.h"
#include "GLRenderLib.h"

#define  BASIS       0x1

typedef struct _KGP_
   {
    // 3D Plot
    char* Title          ;
    int   Xdim           ;
    int   Ydim           ;
    float* DataPointer    ;

    // Manager
    HWND  ParentWin      ;

    // Debug flag
    bool Debug           ;

   } KGP ;
//---------------------------------------------------------------------------
class TPlotForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Open1;
        TMenuItem *Openasnew1;
        TMenuItem *Save1;
        TMenuItem *Print1;
        TMenuItem *N1;
        TMenuItem *Save2;
        TMenuItem *Close1;
        TMenuItem *Options1;
        TMenuItem *Preferians1;
        TMenuItem *Debug1;
        TMenuItem *N2;
        TMenuItem *Info1;
        TMenuItem *About1;
        TStatusBar *StatusBar1;
        TGLRender *OpenGLPanel1;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall OpenGLPanel1Paint(TObject *Sender);
        void __fastcall OpenGLPanel1Resize(TObject *Sender);
        void __fastcall OpenGLPanel1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall FormKeyPress(TObject *Sender, char &Key);
        void __fastcall OpenGLPanel1RenderInit(TObject *Sender);
private:	// User declarations
         // OpenGL options
            KGP   PlotData    ;
            float DeltaY      ;
            float DeltaX      ;
            float DeltaAngel  ;

            bool Mode      ;
            float Alpfa    ;
            float Beta     ;
            float Gama     ;
            float Scale    ;
            float Xpos     ;
            float Ypos     ;
            float Zpos     ;

            int PrevMousePosX  ;
            int PrevMousePosY  ;

            int PlotMode   ;
            // Color
              // BackGround
              TColor BackGroundColor ;
              float  BackGroundAlpha ;
              // fog params
              float  Density ;
              DWORD  FogMode ;
              float  FogColor[4] ;

        void __fastcall TColorToGL ( TColor Color , float& R , float& G , float& B) ;
public:		// User declarations
        __fastcall TPlotForm(TComponent* Owner);
        __fastcall TPlotForm(TComponent* Owner , void* Data );
        __fastcall ~TPlotForm();
};
//---------------------------------------------------------------------------
//extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
