//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uShell.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"



typedef int ( *CPFunc )(void* ) ;
typedef int ( *CPCControl )(void)  ;

typedef struct _KGP_
   {
    // 3D Plot
    char* Title          ;
    int   Xdim           ;
    int   YDim           ;
    void* DataPointer    ;

    // Manager
    HWND  ParentWin      ;

    // Debug flag
    bool Debug           ;

   } KGP ;



TForm1 *Form1;
HMODULE  Mod ;
CPFunc   CreatePlot ;
CPCControl  CreateSurfaceControlObject ;
CPCControl  DeleteSurfaceControlObject ;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  Mod = LoadLibrary ("Modules\\kgp.dll") ;
  CreatePlot = (CPFunc)GetProcAddress ( Mod , "@CreatePloter$qqspv" ) ;
  CreateSurfaceControlObject = (CPCControl)GetProcAddress ( Mod , "@CreateSurfaceControlObject$qqsv" ) ;
  DeleteSurfaceControlObject = (CPCControl)GetProcAddress ( Mod , "@DeleteSurfaceControlObject$qqsv" ) ;

  CreateSurfaceControlObject () ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  DeleteSurfaceControlObject () ;
  FreeLibrary ( Mod ) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
 float Surface [50][50] ;
 for ( int x = 0 ; x < 50 ; x ++ )
      {
       for ( int y = 0 ; y < 50 ; y ++ )
            {
             Surface [x][y] = exp (-0.01*(pow(25-x,2)+pow(25-y , 2))) * ( pow( cos(0.3*(25-x)) , 2) + pow (cos(0.5
             *(25-y)),2)) ;
                   //Surface [x][y] = exp (-0.01*(pow(x-25,2)+pow(y-25,2))) + exp (-0.01*(pow(x-30,2)+pow(y-40,2))); ;
            }
      }

 KGP Data ;
 Data.Title = "Test surface" ;
 Data.Xdim  = 50 ;
 Data.YDim  = 50 ;
 Data.DataPointer = (void*)Surface ;
 Data.ParentWin   = this -> Handle ;
 Data.Debug = true ;
 CreatePlot ( (void*) &Data) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 float Sur [11][11] ;
 for ( int x = 0 ; x < 11 ; x ++ )
      {
       for ( int y = 0 ; y < 11 ; y ++ )
            {
             Sur [x][y]  = 0 ;
            }
      }

 KGP Data ;
 Data.Title = "web" ;
 Data.Xdim  = 11 ;
 Data.YDim  = 11 ;
 Data.DataPointer = (void*)Sur ;
 Data.ParentWin   = this -> Handle ;
 Data.Debug = true ;
 CreatePlot ( (void*) &Data) ;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  float Surface [50][50] ;
  for ( int x = 0 ; x < 50 ; x ++ )
      {
       for ( int y = 0 ; y < 50 ; y ++ )
            {
              int X=x  ;
             int Y=y   ;
             Surface [x][y] = exp (-0.01*(pow(X-25,2)+pow(Y-25,2))) + exp (-0.01*(pow(X-30,2)+pow(Y-40,2))); ;
            }
      }

  KGP Data ;
  Data.Title = "Exponent" ;
  Data.Xdim  = 50 ;
  Data.YDim  = 50 ;
  Data.DataPointer = (void*)Surface ;
  Data.ParentWin   = this -> Handle ;
  Data.Debug = true ;
  CreatePlot ( (void*) &Data) ;
}
//---------------------------------------------------------------------------

